=== modified file 'configure.ac'
--- configure.ac	2008-12-18 18:54:05 +0000
+++ configure.ac	2008-12-18 19:33:40 +0000
@@ -1452,7 +1452,8 @@
 then
   if test "$ac_datarace" = "yes"
   then
-    CXXFLAGS="${CXXFLAGS} -xinstrument-datarace"
+    CFLAGS="${CFLAGS} -xinstrument=datarace"
+    CXXFLAGS="${CXXFLAGS} -xinstrument=datarace"
   fi
   CC_WARNINGS="-v -xc99=all -errtags=yes"
   CXX_WARNINGS="+w +w2 -xport64 -errtags=yes -erroff=attrskipunsup -compat=5"

=== modified file 'mysys/thr_alarm.cc'
--- mysys/thr_alarm.cc	2008-12-18 06:53:47 +0000
+++ mysys/thr_alarm.cc	2008-12-18 20:31:21 +0000
@@ -352,8 +352,8 @@
     else
     {
       time_t now= time(NULL);
-      uint32_t next= now+10-(now%10);
-      while ((alarm_data=(ALARM*) queue_top(&alarm_queue))->expire_time <= now)
+      time_t next= now+10-(now%10);
+      while ((alarm_data= (ALARM*) queue_top(&alarm_queue))->expire_time <= now)
       {
         alarm_data->alarmed=1;			/* Info to thread */
         if (pthread_equal(alarm_data->thread,alarm_thread) ||
@@ -372,7 +372,7 @@
 #ifndef USE_ALARM_THREAD
       if (alarm_queue.elements)
       {
-        alarm((uint) (alarm_data->expire_time-now));
+        alarm((uint32_t) (alarm_data->expire_time-now));
         next_alarm_expire_time= alarm_data->expire_time;
       }
 #endif

=== modified file 'mysys/thr_alarm.h'
--- mysys/thr_alarm.h	2008-12-01 17:53:42 +0000
+++ mysys/thr_alarm.h	2008-12-18 20:31:21 +0000
@@ -71,7 +71,7 @@
 typedef thr_alarm_entry* thr_alarm_t;
 
 typedef struct st_alarm {
-  uint32_t expire_time;
+  time_t expire_time;
   thr_alarm_entry alarmed;		/* set when alarm is due */
   pthread_t thread;
   my_thread_id thread_id;

=== modified file 'tests/test-run.pl'
--- tests/test-run.pl	2008-12-17 04:50:59 +0000
+++ tests/test-run.pl	2008-12-18 20:20:13 +0000
@@ -186,7 +186,8 @@
 our $opt_manual_gdb;
 our $opt_manual_ddd;
 our $opt_manual_debug;
-our $opt_mtr_build_thread=0;
+# Magic number -69.4 results in traditional test ports starting from 9306.
+our $opt_mtr_build_thread=-69.4;
 our $opt_debugger;
 our $opt_client_debugger;
 
@@ -426,9 +427,6 @@
 
   my $opt_comment;
 
-  # Magic number -69.4 results in traditional test ports starting from 9306.
-  set_mtr_build_thread_ports(-69.4);
-
   # If so requested, we try to avail ourselves of a unique build thread number.
   if ( $ENV{'MTR_BUILD_THREAD'} ) {
     if ( lc($ENV{'MTR_BUILD_THREAD'}) eq 'auto' ) {
@@ -621,7 +619,7 @@
     $glob_basedir= dirname($glob_basedir);
   }
 
-  if ( -d $opt_testdir and -d $opt_vardir
+  if ( $opt_testdir and -d $opt_testdir and $opt_vardir and -d $opt_vardir
          and -f "$opt_vardir/../../drizzled/drizzled")
   {
     # probably in a VPATH build
@@ -1072,7 +1070,6 @@
 
 sub set_mtr_build_thread_ports($) {
   my $mtr_build_thread= shift;
-  $mtr_build_thread= ($mtr_build_thread % 200) - 100;
 
   if ( lc($mtr_build_thread) eq 'auto' ) {
     print "Requesting build thread... ";
@@ -1080,9 +1077,11 @@
     print "got ".$mtr_build_thread."\n";
   }
 
+  $mtr_build_thread= (($mtr_build_thread * 10) % 2000) - 1000;
+
   # Up to two masters, up to three slaves
   # A magic value in command_line_setup depends on these equations.
-  $opt_master_myport=         $mtr_build_thread * 10 + 10000; # and 1
+  $opt_master_myport=         $mtr_build_thread + 9000; # and 1
   $opt_slave_myport=          $opt_master_myport + 2;  # and 3 4
 
   if ( $opt_master_myport < 5001 or $opt_master_myport + 10 >= 32767 )

